<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!-- 
 *  Copyright (c) 2012, Texas Instruments Incorporated
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  *  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  *  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  *  Neither the name of Texas Instruments Incorporated nor the names of
 *     its contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 *  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
-->
<html>
<head>
    <title>Linux Utils 3.23.00.01 Release Notes </title>
    <!-- For now, we use the doxygen style sheet -->
    <link type="text/css" rel="stylesheet" href="docs/html/doxygen.css">
    <!-- doxygen's css .memproto's all have tables for a little extra pad...
         don't like tables, so give 'em a little extra left pad ourselves
    --->
    <style type="text/css">
    body {
        margin: 20px;
    }
    .memproto {
        padding-left: 6px;
    }
    </style>
</head>
<body>
<table width="100%">
  <tbody>
    <tr>
      <td bgcolor="black" width="1">
        <a href="http://www.ti.com">
          <img border=0 src="docs/html/tilogo.gif" alt="Texas Instruments">
        </a>
      </td>
      <td bgcolor="red">
        <img src="docs/html/titagline.gif" alt="Technology for Innovators(tm)">
      </td>
    </tr>
  </tbody>
</table>

<h1 align="center">Linux Utils 3.23.00.01 Release Notes </h1>
<h2 align="center">May 2012</h2>


<p>
This Linux Utils Release is targetted for the various DaVinci- and OMAP-based 
platforms running Linux, but is generally usable for any Linux-based system.
</p>
<p align="center">
<a href="#Introduction">Introduction</a>,
<a href="#CMEM">CMEM</a>,
<a href="#SDMA">SDMA</a>,
<a href="#Documentation">Documentation</a>,
<a href="#Whats_New">What's New</a>,
<a href="#Upgrade_Info">Upgrade Info</a>,
<a href="#Compatibility">Compatibility Information</a>,
<a href="#Device_Support">Device Support</a>,
<a href="#Validation">Validation Info</a>,
<a href="#Known_Issues">Known Issues</a>,
<a href="#Examples">Examples</a>,
<a href="#Version">Version Information</a>,
<a href="#Support">Technical Support</a>.
</p>

<hr>

<h2><a name="Introduction">Introduction</a></h2>

<p>
The Linux Utils utility package provides the ability for user-mode
applications to access the CMEM and SDMA utility libraries.
</p>

<h3><a name="CMEM">CMEM</a></h3>

<p>
The CMEM (Contiguous Memory) utility library provides the ability for
user-mode applications to allocate and free blocks of physically contiguous
memory.  This is typically done to manage multimedia data buffers which
will be worked on by multimedia algorithms, but the memory provided by this
library can be used for any purpose.
</p>

<p>
The reason multimedia algorithms often require physically contiguous
memory is that sometimes they're on another processor which may not
contain an MMU (e.g. the C64P processor on a DM644x device), and/or
Linux-based algorithms utilize hardware accelerators (e.g. DMA, image
co-processors, etc) which don't access memory through an MMU.
</p>

<p>
The CMEM module consists of the following packages:
</p>

<ul>
  <li><b><tt>ti.sdo.linuxutils.cmem</tt></b> - The CMEM user-mode library and
  kernel mode driver.</li>
</ul>

<p>
The CMEM module supports the following devices:
</p>

<ul>
  <li><b><tt>all supported platforms for this release</tt></b></li>
</ul>

<h3><a name="SDMA">SDMA</a></h3>

<p>
SDMA refers to the "System DMA" incorporated on the OMAP35x family of devices.
</p>

<p>
The SDMA utility library provides the ability for user-mode
applications to request SDMA channels and operate on a channel using direct,
memory-mapped access to the channel's DMA registers (Framework Components
contains a layer named SCPY to manage this direct access).  It also provides
"blocking" support for waiting for the completion of a transfer on a
particular channel.
</p>

<p>
Performing direct DMA register access helps to alleviate the overhead of
initiating, and checking completion of, DMA transfers, since the usual method
involves calling down into the Linux kernel somehow.  Transfer completion
checking is achieved by first querying an application status flag, and only
when it is known that the transfer is NOT complete will a blocking kernel
module call be made.
</p>

<p>
The SDMA module consists of the following packages:
</p>

<ul>
  <li><b><tt>ti.sdo.linuxutils.sdma</tt></b> - The SDMA user-mode library and
  kernel mode driver.</li>
</ul>

<p>
The SDMA module supports the following devices:
</p>

<ul>
  <li><b><tt>OMAP3530</tt></b></li>
</ul>

<hr>

<h2><a name="Documentation">Documentation</a></h2>
<p>
The following documentation is available:
</p>
<ul>
  <li>
    <b>Linux Utils Application Programming Interface (API) Reference
    Guide</b> (<a href="docs/html/index.html">HTML</a> |
    <a href="docs/html/linuxutils_3_23_00_01.chm">CHM</a>)
  </li>
  <li>A description of all the <a href="xdoc/index.html">packages</a>
  in this product.</li>
</ul>

<p>
Release notes from previous releases are also available in the <a
href="relnotes_archive">relnotes_archive</a> directory.
</p>

<hr>
<h2><a name="Whats_New">What's New</a></h2>
<p>The following significant changes have been made since Linux Utils 2.00</p>

<div class="memitem">
<div class="memproto">3.23.00.01 </div>
<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00087603</td>
      <td>Linux Utils CMEM package doesn't automatically build cmemk.ko kernel module
</td>
    </tr>

  </tbody>
</table>
</li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00092595</td>
      <td>Remove Android support
</td>
    </tr>

  </tbody>
</table>
</li>
</ul>
</div>
</div>
<br />

<div class="memitem">
<div class="memproto">3.22.00.02 </div>
<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00087225</td>
      <td>CMEM kernel module build has undefined symbol "arm926_dma_map_area" for OMAP-L138 & DM365 builds
</td>
    </tr>

  </tbody>
</table>
</li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00087322</td>
      <td>Create separate glibc and uclibc build goals for CMEM
</td>
    </tr>
    <tr>
      <td>SDOCM00087321</td>
      <td>Android support needed for Linux Utils CMEM
</td>
    </tr>

  </tbody>
</table>
</li>
</ul>
</div>
</div>
<br />

<div class="memitem">
<div class="memproto">3.21.00.04 </div>
<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00081998</td>
      <td>CMEMK bug causes kernel Oops during insmod for "debug" build
</td>
    </tr>
    <tr>
      <td>SDOCM00082132</td>
      <td>Linux Utils CMEM_getBlockAttrs() API doesn't return error when blockId is out-of-bouds
</td>
    </tr>
    <tr>
      <td>SDOCM00082129</td>
      <td>non-LSP 2.10 code in Linux Utils edmak.c should be qualified with #ifndef LSP_210
</td>
    </tr>

  </tbody>
</table>
</li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00082136</td>
      <td>Need to update Linux Utils sdmak module to conform to newer unlocked_ioctl interface and remove old, deprecated mutex
</td>
    </tr>

  </tbody>
</table>
</li>
</ul>
</div>
</div>
<br />

<div class="memitem">
<div class="memproto">3.00.00.00 </div>
<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00068571</td>
      <td>CMEM kernel module doesn't handle CMEM_cacheInv()/CMEM_cacheWb()/CMEM_cacheWbInv() properly
</td>
    </tr>
    <tr>
      <td>SDOCM00066798</td>
      <td>CMEM needs to cache-invalidate heap block during "free" operation for cached allocations
</td>
    </tr>
  </tbody>
</table>
</li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00072211</td>
      <td>CMEM should allow config for fallback to a heap allocation if a pool-based allocation can't be achieved
</td>
    </tr>
  </tbody>
</table>
</li>
</ul>
</div>
</div>
<br />

<div class="memitem">
<div class="memproto">2.26.03.06 </div>
<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00087222</td>
      <td>CMEM kernel module build has undefined symbol "arm926_dma_map_area" for OMAP-L138 & DM365 builds
</td>
    </tr>

  </tbody>
</table>
</li>

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">2.26.02.05 </div>
<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00066507</td>
      <td>Linux Utils CMEM_getBlockAttrs() API doesn't return error when blockId is out-of-bouds
</td>
    </tr>
    <tr>
      <td>SDOCM00073843</td>
      <td>non-LSP 2.10 code in Linux Utils edmak.c should be qualified with #ifndef LSP_210
</td>
    </tr>
    <tr>
      <td>SDOCM00079115</td>
      <td>CMEMK bug causes kernel Oops during insmod for "debug" build
</td>
    </tr>

  </tbody>
</table>
</li>

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00081489</td>
      <td>Need to update Linux Utils sdmak module to conform to newer unlocked_ioctl interface and remove old, deprecated mutex
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">2.26.01.02 </div>
<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00076769</td>
      <td>Linux Utils kernel modules need modifications to conform to Linux kernel v2.6.37
</td>
    </tr>
  </tbody>
</table>
</li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
  </tbody>
</table>
</li>
</ul>
</div>
</div>
<br />

<div class="memitem">
<div class="memproto">2.26.00.01 </div>
<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00075810</td>
      <td>Linux Utils kernel modules need to use 'unlocked_ioctl' member of file_operations struct (instead of 'ioctl' member)
</td>
    </tr>
  </tbody>
</table>
</li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
  </tbody>
</table>
</li>
</ul>
</div>
</div>
<br />
<div class="memitem">
<div class="memproto">2.25.05.11 </div>
<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00072689</td>
      <td>CMEM's kernel module "heap fallback" feature (useHeapIfPoolUnavailable=1) has a few bugs
</td>
    </tr>
  </tbody>
</table>
</li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
  </tbody>
</table>
</li>
</ul>
</div>
</div>
<br />
<div class="memitem">
<div class="memproto">2.25.04.10 </div>
<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00071596</td>
      <td>CMEM still has one more place where it uses older pre-2.6.34 Linux kernel cache calls
</td>
    </tr>
  </tbody>
</table>
</li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
  </tbody>
</table>
</li>
</ul>
</div>
</div>
<br />
<div class="memitem">
<div class="memproto">2.25.03.09 </div>
<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00071493</td>
      <td>Linux kernel APIs called by CMEM cache flush/clean/invalidate APIs no longer available in Linux versions 2.6.34+
</td>
    </tr>
  </tbody>
</table>
</li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00071207</td>
      <td>CMEM should allow config for fallback to a heap allocation if a pool-based allocation can't be achieved
</td>
    </tr>
  </tbody>
</table>
</li>
</ul>
</div>
</div>
<br />
<div class="memitem">
<div class="memproto">2.25.02.08 </div>
<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00065084</td>
      <td>LinuxUtils kernel modules CMEMK and IRQK need to set file_operations struct .owner field for correct reference counting
</td>
    </tr>
    <tr>
      <td>SDOCM00067560</td>
      <td>CMEM kernel module doesn't handle CMEM_cacheInv()/CMEM_cacheWb()/CMEM_cacheWbInv() properly
</td>
    </tr>
    <tr>
      <td>SDOCM00066794</td>
      <td>CMEM needs to cache-invalidate heap block during "free" operation for cached allocations
</td>
    </tr>
  </tbody>
</table>
</li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00065628</td>
      <td>Update LinuxUtils EDMA module to handle newly coded return value from edma_alloc_channel()
</td>
    </tr>
  </tbody>
</table>
</li>
</ul>
</div>
</div>
<br />
<div class="memitem">
<div class="memproto">2.25.01.06 </div>
<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00064125</td>
      <td>LinuxUtils SDMAK kernel driver needs  to base channel ownership on file struct instead of task struct
</td>
    </tr>
  </tbody>
</table>
</li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
  </tbody>
</table>
</li>
</ul>
</div>
</div>
<br />
<div class="memitem">
<div class="memproto">2.25</div>
<div class="memdoc">
<ul>
  <li>New features
    <ul>
      <li>Device validation on OMAP-L138 and DM6467T</li>
    </ul>
  </li>
  <br />
  <li>General
    <ul>
      <li>
        While this release fixes a few bugs (see immediately below), the
        biggest change is with the ioctl() command IDs - they have changed
        to incorporate a module-specific "magic" code so as to not conflict
        with other device driver ioctl() command IDs.  This fact means that
        it is critical that the user update the sub-module user libraries
        in conjunction with their associated kernel modules, although a
        mismatch between kernel module and user library will be reported
        during the module's "init" function (and the "init" will fail).
      </li>
    </ul>
  </li>

  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00062638</td>
      <td>CMEM_registerAlloc() API bug with pool-based allocations
</td>
    </tr>
    <tr>
      <td>SDOCM00062704</td>
      <td>LinuxUtils EDMA kernel module does not correctly auto-release resources in a multi-threaded application
</td>
    </tr>

  </tbody>
</table>
  </li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00061526</td>
      <td>Need to remove "init_mm" reference from CMEM kernel module source code (cmemk.c)
</td>
    </tr>

  </tbody>
</table>
  </li>
</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">2.24.03</div>
<div class="memdoc">
<ul>
  <li>General
    <ul>
      <li>
        Added sharing capability to VICP/IRQK resources.  This allows separate
        processes to access the same resource simultaneously.  For a given
        process, or threads within a process, sharing is accomplished by
        allowing mutliple "register" w/o any intervening "unregister".
      </li>
    </ul>
  </li>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
  </tbody>
</table>
  </li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00060312</td>
      <td>Allow sharing of Linux Utils VICP resources
</td>
    </tr>
  </tbody>
</table>
  </li>
</ul>
</div>
</div>
<br />
<div class="memitem">
<div class="memproto">2.24.02</div>
<div class="memdoc">
<ul>
  <li>General
    <ul>
      <li>
        Fixed problem in EDMA (see Headline immediately below in defects).
      </li>
    </ul>
  </li>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00058845</td>
      <td>EDMA module in Linux Utils should not allow partial freeing of a multi-PaRAM EDMA_getResource() allocation
</td>
    </tr>
  </tbody>
</table>
  </li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
  </tbody>
</table>
  </li>
</ul>
</div>
</div>
<br />
<div class="memitem">
<div class="memproto">2.24.01</div>
<div class="memdoc">
<ul>
  <li>General
    <ul>
      <li>
          CMEMK now tracks buffer ownership through the calling process' file
          descriptor instead of the calling process' "task" descriptor.
      </li>
    </ul>
  </li>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
  </tbody>
</table>
</li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00058042</td>
      <td>CMEM should track buffer ownership through the file descriptor instead of the process descriptor
</td>
    </tr>
  </tbody>
</table>
</li>
</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">2.24</div>
<div class="memdoc">
<ul>
  <li>General
    <ul>
      <li>CMEMK can now be insmod'ed w/o any memory blocks</li>
    </ul>
  </li>

  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00057541</td>
      <td>Linux Utils IRQK module can crash kernel if an operation is requested on a resource that's already been released
</td>
    </tr>
    <tr>
      <td>SDOCM00057542</td>
      <td>Linux Utils EDMAK module does not have mutex locks around registration list manipulation
</td>
    </tr>

  </tbody>
</table>
  </li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00056992</td>
      <td>CMEM should allow no memory block to be specified, so it can be used just for cache operations and virt-to-phys translations
</td>
    </tr>

  </tbody>
</table>
  </li>
</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">2.23.01</div>
<div class="memdoc">
<ul>
  <li>General
    <ul>
      <li>Added "banner" display to all kernel modules</li>
      <li>CMEM now registers its memory blocks with Linux kernel</li>
      <li>All kernel modules now support varied Linux 2.6.x versions</li>
      <li>Enhanced resource ownership for multiple owners (EDMAK and CMEMK></li>
      <li>Added "close on exec" flag for all kernel modules' open() calls</li>
    </ul>
  </li>

  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00056304</td>
      <td>Linux Utils IRQK kernel module returns wrong value from irq handler function irqHandler()
</td>
    </tr>

  </tbody>
</table>
  </li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>

  </tbody>
</table>
  </li>
</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">2.23</div>
<div class="memdoc">
<ul>
  <li>General
    <ul>
      <li>Fixed problem with never-ending "make clean" when issued in
        ti/sdo/linuxutils/edma/apps</li>
      <li>Added OMAPL137 flavor of ti/sdo/linuxutils/cmem/apps/insmod_rmmod
        shell script "insmod_rmmod_omapL137.sh"</li>
      <li>Validated on Linux 2.6.29 kernel</li>
      <li>Added "resource tracking" to CMEM and EDMA kernel modules, so that
        unreleased resources get automatically released upon close() and
        'rmmod'</li>
    </ul>
  </li>

  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00054009</td>
      <td>Linux Utils 2.22.01 does not "export" insmod_rmmod_omapL137.sh
</td>
    </tr>

  </tbody>
</table>
  </li>
  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00045995</td>
      <td>Validate Linux Utils on 2.6.27 kernel
</td>
    </tr>
    <tr>
      <td>SDOCM00046045</td>
      <td>CMEM should track owner process of buffers and force-free owned buffers when process closes device file
</td>
    </tr>
    <tr>
      <td>SDOCM00055139</td>
      <td>LinuxUtils edmak should release all resources if processes that have requested resources are no longer running
</td>
    </tr>

  </tbody>
</table>
  </li>
</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">2.22</div>
<div class="memdoc">
<ul>
  <li>General
    <ul>
      <li>Modified IRQ module to conform to definitions in LSP 2.10</li>
      <li>Added "glibc" and "uclibc" goals in interface makefiles to better
        facilitate building for individual toolchains</li>
    </ul>
  </li>

<!--
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
  </tbody>
</table>
  </li>
-->

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00050455</td>
      <td>Create a makefile variable called RULES_MAKE to point to Rules.make</td>
    </tr>
  </tbody>
</table>
  </li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">2.21</div>
<div class="memdoc">
<ul>
  <li>General
    <ul>
      <li>Added VICP module</li>
      <li>Added IRQ module</li>
    </ul>
  </li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">2.20</div>
<div class="memdoc">
<ul>
  <li>General
    <ul>
      <li>Added SDMA module</li>
      <li>Added EDMA module</li>
      <li>Added 2nd memory block support to CMEM</li>
    </ul>
  </li>

  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDSCM00019164</td>
      <td>Failure to insmod cmem results in misleading Codec Engine error
          messages</td>
    </tr>
  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">2.10</div>
<div class="memdoc">
<ul>
  <li>General
    <ul>
      <li>Added allowOverlap insmod command line argument</li>
      <li>Added CMEM_getBlock() for retrieving CMEM memory block bounds</li>
    </ul>
  </li>

  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDSCM00019818</td>
      <td>cat /proc/cmem needs more than one page of memory to avoid buffer
        overflow
      </td>
    </tr>
  </tbody>
</table>
  </li>

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDSCM00023295</td>
      <td>CMEM needs insmod config parameter to support allowing kernel memory
        & CMEM memory to overlap
    </tr>
  </tbody>
</table>
  </li>
</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">2.00</div>
<div class="memdoc">
<ul>
  <li>General
    <ul>
      <li>Added cached buffer support</li>
      <li>Added heap-based allocation in addition to pool based allocation</li>
      <li>Added overlap detection for kernel memory and CMEM memory, as well
        as an 'insmod' parameter for allowing this overlap</li>
      <li>Added support for building for DM355</li>
      <li>Modified licensing.  The CMEM kernel driver is now licensed under
        the GPL 2 license.  The CMEM user-mode library is now licensed under
        the LGPL 2 license.
      </li>
    </ul>
  </li>

  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDSCM00019947</td>
      <td>CMEM causes Linux kernel Oops when insufficient memory exists for
        specified pools
      </td>
    </tr>
  </tbody>
</table>
  </li>

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="15%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDSCM00018886</td>
      <td>CMEM should allow an option not to partition its area into pools but
        to use it for allocation of arbitrarily-sized buffers</td>
    </tr>
  </tbody>
</table>
  </li>

</ul>
</div>
</div>

<br />


<hr>
<h2><a name="Upgrade_Info">Upgrade Information</a></h2>
<p>
The Linux Utils packages are available in the "packages/"
subdirectory of the product.  If you have a previous release of the
Linux Utils (or CMEM) product, you can install this release next to it, and
modify your application and/or server builds to use this newer release.</p>
<p>
If you're using the DVEVM, this can be done by setting the
<b>CMEM_INSTALL_DIR</b> variable in the <tt>Rules.make</tt> file at the
top of the DVEVM distribution directory.</p>

<h2>Compatibility Breaks!</h2>
<p>None</p>

<p>
Note, if you're upgrading from a release earlier than Linux Utils 3.00.00.00,
be sure to review the <b>Upgrade</b> section for each of the releases between
your current release and this one.  Previous release notes are
available in the <a href="relnotes_archive">relnotes_archive</a> directory.
</p>

<hr>
<h2><a name="Compatibility">Compatibility Information</a></h2>
<p>
The details provided below describe each package's compatibility with the
previous release.
</p>
<p>
Note, the <a href="xdoc/index.html">Configuration Reference Guide</a> contains
further details about each package.
</p>
<ul>
    <li>
        <b><tt>ti.sdo.linuxutils.cmem</tt></b> - This package is compatible
        with the previous release.
        (Compatibility key: <i>2,2,0</i> -> 2,2,0)
    </li>
    <li>
        <b><tt>ti.sdo.linuxutils.sdma</tt></b> - This package is compatible
        with the previous release.
        (Compatibility key: <i>1,0,0</i> -> 1,0,0)
    </li>
</ul>

<p>
If migrating from a release prior to Linux Utils 3.00.00.00, consult previous
releases available in the <a
href="relnotes_archive">relnotes_archive</a> directory.
</p>

<h3>Compatibility Key Definitions</h3>
<p>
Compatibility keys are intentionally independent of Marketing product
numbers and are intended to:
<ol>
  <li>Enable tooling to identify incompatibilities between components,
  and</li>
  <li>Convey a level of compatibility between different releases to
  set end user expectations.</li>
</ol>
</p>

<p>
Compatibility keys are composed of 3 comma-delimited numbers - M,S,R
- where:
<ul>
  <li><b>M = Major</b>.  A difference in M indicates a break in
  compatibility.</li>
  <li><b>S = Source</b>.  A difference in S indicates source
  compability.  That is, the user's source doesn't require change, but
  <i>does</i> require rebuilding.</li>
  <li><b>R = Radix</b>.  A difference in R indicates an introduction
  of new features, but compatibility with previous interfaces has not
  broken.  If libraries are provided by the package, an application
  must re-link with the new libraries, but not rebuild from source.</li>
</ul>
</p>


<hr>
<h2><a name="Device_Support">Device Support</a></h2>

<p>
This release supports the following devices:
<ul>
  <li>OMAP-L138:
    <ul>
      <li>running ARM9 Linux 2.6.37 from DaVinci-PSP-SDK-03.21.00.04 (earlier Linux also supported)</li>
    </ul>
  </li>
  <li>TI814X EVM:
    <ul>
      <li>running ARM9 Linux 2.6.37 from TI814X-LINUX-PSP-04.01.00.03 (earlier Linux also supported)</li>
    </ul>
  </li>
  <li>TI816X EVM:
    <ul>
      <li>running ARM9 Linux 2.6.37 from TI816X-LINUX-PSP-04.00.00.10 (earlier Linux also supported)</li>
    </ul>
  </li>
</ul>

</p>


<hr>
<h2><a name="Validation">Validation</a></h2>
<p>
This release was validated against using the following components:
</p>

<ul>
  <li>XDC Tools 3.23.00.32</li>
  <li>Linux release 2.6.37</li>
</ul>

<p>
This release was validated in the following configurations:
<ul>
  <li>OMAP-L138:
    <ul>
      <li>dual-processor configuration, running ARM9 Linux 2.6.37 from DaVinci-PSP-SDK-03.21.00.04</li>
    </ul>
  </li>
  <li>TI814X EVM:
    <ul>
      <li>dual-processor configuration, running ARM9 Linux 2.6.37 from TI814X-LINUX-PSP-04.01.00.03</li>
    </ul>
  </li>
  <li>TI816X EVM:
    <ul>
      <li>dual-processor configuration, running ARM9 Linux 2.6.37 from TI816X-LINUX-PSP-04.00.00.10</li>
    </ul>
  </li>
</ul>

<hr>
<h2><a name="Known_Issues">Known Issues</a></h2>
<p>
</p>

<hr>
<h2><a name="Examples">Examples</a></h2>
<p>Linux Utils example apps and tests are provided in the
ti/sdo/linuxutils/*/apps directory.
</p>
<!--
<ul>
  <li><a href="examples/build_instructions.html">Example Build
  Instructions</a></li>
</ul>
-->

<hr>
<h2><a name="Version">Version Information</a></h2>
<p>
This product's version follows a version format, <b>M.mm.pp.bb</b>,
where <b>M</b> is a single digit Major number, <b>mm</b> is 2 digit
minor number, <b>pp</b> is a 2 digit patch number, and <b>b</b> is an
unrestricted set of digits used as an incrementing build counter.
</p>

<p>
To support multiple side-by-side installations of the product, the
product version is encoded in the top level directory,
ex. <b>linuxutils_3_23_00_01</b>.
</p>

<hr>
<h2><a name="Support">Technical Support</a></h2>
<p>For technical support, contact <a href="mailto:softwaresupport@ti.com">softwaresupport@ti.com</a></p>

<p>
Check the following web site for updates: <a href="http://software-dl.ti.com/dsps/dsps_public_sw/sdo_sb/targetcontent/linuxutils/index.html">http://software-dl.ti.com/dsps/dsps_public_sw/sdo_sb/targetcontent/linuxutils/index.html</a>
</p>

<hr>
<p>
Last updated: May 30, 2012
</p>
</body>
</html>
<!--
/*
 * @(#) linuxutils_3_23_00_01; 1, 0, 0,1; 5-30-2012 11:51:37; /db/atree/library/trees/linuxutils/linuxutils-l01/src/ xlibrary

 */
-->

